/* Dieses Plugin kndigt einen HLTV-Server beim Connect
und auf Befehl an. Plugin von [WING]Black Knight 14.07.2003 */

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>
#define ACCESS_CONSOLE 131072
#define MAX_IP_LENGTH 22
new STRING_VERSION[MAX_DATA_LENGTH] = "1.1";

new hltvname[MAX_NAME_LENGTH];
new hltvid=0;
new hltvteam=0;

public admin_hltv(HLCommand,HLData,HLUserName,UserIndex){
	a_hltv();
	return PLUGIN_CONTINUE;
}

public a_hltv() {
	if(hltvteam==TEAM_PROXY) {
		new text[MAX_TEXT_LENGTH];
		new hltvspecs[MAX_NAME_LENGTH];
		new hltvslots[MAX_NAME_LENGTH];
		new hltvdelay[MAX_NAME_LENGTH];
		new iPort;
		new hltvip[MAX_IP_LENGTH];

		get_userinfo(hltvname,"hltv_specs",hltvspecs,MAX_NAME_LENGTH);
		get_userinfo(hltvname,"hltv_slots",hltvslots,MAX_NAME_LENGTH);
		get_userinfo(hltvname,"hltv_delay",hltvdelay,MAX_NAME_LENGTH);
		get_userIP(hltvname,hltvip,MAX_IP_LENGTH,iPort);
		snprintf(text, MAX_TEXT_LENGTH, "%s online:^n%s:%d^nSlots %s/%s, Delay %s s",hltvname,hltvip,iPort,hltvspecs,hltvslots,hltvdelay);
		typesay(text,10,68,153,125);
		say("Type ^"hltvconnect^" in chat to get redirected to the HLTV!");
	} else {
		typesay("No HLTV-Server online!",3,181,40,44);
	}
	return PLUGIN_HANDLED;
}

public plugin_disconnect(HLUserName, UserIndex){
	if (hltvid==UserIndex){
		hltvid=0;
		hltvteam=0;
		typesay("The HLTV is offline!",3,181,40,44);
	}
	return PLUGIN_CONTINUE;
}

public plugin_info(HLOldName, HLNewName, UserIndex){
	new Name[MAX_NAME_LENGTH];
	new UserID,WONID,Team,Dead;
	new sAuthID[MAX_AUTHID_LENGTH];
	if(UserIndex>0){
		playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID,Team,Dead,sAuthID);
	}
	else{
		return PLUGIN_CONTINUE;
	}

	if(Team==TEAM_PROXY){
		if(hltvteam!=TEAM_PROXY){
			new text[MAX_TEXT_LENGTH];
			new delay;
			get_userinfo(Name,"hltv_delay",text,MAX_TEXT_LENGTH);
			delay=strtonum(text);
			if(delay!=0){
				hltvteam=TEAM_PROXY;
				hltvid=UserIndex;
				strcpy(hltvname,Name,MAX_NAME_LENGTH);
				a_hltv();
			}
			return PLUGIN_CONTINUE;
		}
		new sHLOldName[MAX_NAME_LENGTH];
		new sHLNewName[MAX_NAME_LENGTH];
		convert_string(HLOldName,sHLOldName,MAX_NAME_LENGTH);
		convert_string(HLNewName,sHLNewName,MAX_NAME_LENGTH);
		if(!streq(sHLOldName,sHLNewName)){
			strcpy(hltvname,Name,MAX_NAME_LENGTH);
		}
	}
	
	return PLUGIN_CONTINUE;
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];

	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strstripquotes(Data);
	if(streq(Data, "hltvconnect")==1) {
		hltvconnect(User);
	}

	return PLUGIN_CONTINUE;
}

public admin_hltv_connect(HLCommand,HLData,HLUserName,UserIndex) {
	if(hltvid==0){
		selfmessage("No HLTV online!");
		return PLUGIN_HANDLED;
	}

	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];

	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	strstripquotes(Data);
	if(strlen(Data)==0) {
		hltvconnect(User);
		return PLUGIN_HANDLED;
	}
	new UIndex;
	get_userindex(Data,UIndex);
	new Name[MAX_NAME_LENGTH];
	new UserID,WONID,Team,Dead;
	new sAuthID[MAX_AUTHID_LENGTH];
	playerinfo(UIndex,Name,MAX_NAME_LENGTH,UserID,WONID,Team,Dead,sAuthID);
	if(Team==TEAM_PROXY){
		selfmessage("Of course, we let the hltv connect to itself...");
		return PLUGIN_HANDLED;
	}
	else {
		if(auth(User)){
			hltvconnect(Data);
		}
		else{
			selfmessage("Sorry, but you do not have the needed rights!");
		}			
	}
	return PLUGIN_HANDLED;
}

hltvconnect(Data[]){
	new Text[MAX_TEXT_LENGTH];
	new hltvip[MAX_IP_LENGTH];
	new iPort;
	new hltvinfo[MAX_NAME_LENGTH];
	new ihltv;
	get_userIP(hltvname,hltvip,MAX_IP_LENGTH,iPort);
	get_userinfo(hltvname,"hltv_slots",hltvinfo,MAX_NAME_LENGTH);
	ihltv=strtonum(hltvinfo);
	get_userinfo(hltvname,"hltv_specs",hltvinfo,MAX_NAME_LENGTH);
	ihltv-=strtonum(hltvinfo);
	if(ihltv>0){
		snprintf(Text,MAX_TEXT_LENGTH,"%s connected to the HLTV on %s:%d. Type ^"hltvconnect^"^n to follow him/her.",Data,hltvip,iPort);
		say(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"connect %s:%d",hltvip,iPort);
		selfmessage("Redirected to HLTV!");
		execclient(Data,Text);
	}
	else{
		selfmessage("Sorry, no redirection possible, HLTV full!");
	}			
	return PLUGIN_CONTINUE;
}

public plugin_init() {
	plugin_registerinfo("HLTV Announcer plugin","Announces HLTV.",STRING_VERSION);
	plugin_registercmd("admin_hltv","admin_hltv",ACCESS_ALL,"admin_hltv: Shows information about connected hltv.");
	plugin_registercmd("admin_hltv_connect","admin_hltv_connect",ACCESS_ALL,"admin_hltv_connect: Redirects yourself or someone else to the HLTV.");
	plugin_registercmd("say","HandleSay",ACCESS_ALL);
	plugin_registerhelp("say",ACCESS_ALL,"say hltvconnect: Redirects yourself to the HLTV.");

	return PLUGIN_CONTINUE;
}